#include<conio.h>		//getch()
#include <cmath>		//fabs
#include<iostream>		//cin, cout
using namespace std;

class solver													
{	public:
        virtual void solve()=0; //   
		float Left,Right,Eps;   
};
class newton: public solver
{	public:
        newton(float,float);
        void solve();
};
newton::newton(float Le,float Ep)
{	Left=Le;
	Eps=Ep;
}
void newton:: solve()
{   int n=0;
	float x=Left;
	while (fabs(x*x-4)>=Eps)
	{	x=x-(x*x-4)/(2.*x);
		n++;
	}
	cout << "x=" << x << "\n" << "n=" << n << "\n\n";
}
class dichotomy: public solver
{	public:
        dichotomy(float,float,float);
		void solve();        
};
dichotomy::dichotomy(float Le, float Ri, float Ep)
{	Left=Le;
	Right=Ri;
	Eps=Ep;
}
void dichotomy::solve()
{   float xR=Right,xL=Left,x;
	int n=0;    
    if((xR*xR-4)*(xL*xL-4)>0) cout << "Error\n\n";
	else
	{	while (fabs(xR-xL)>=Eps)
		{   x=(xL+xR)/2;
			n++;		
		    if (x*x-4==0) break;    
		    if ((xL*xL-4)*(x*x-4)<0) xR=x;
			else xL=x;
		 }    
		cout << "x=" << (xL+xR)/2. << "\nn=" << n << "\n\n"; 
	}
}
class secant: public solver
{	public:
        void solve();
        secant(float,float,float);
};
secant::secant(float Le,float Ep,float Ri)
{	Left=Le;
	Right=Ri;
	Eps=Ep;
}
void secant::solve()
{   float xR=Right,xL=Left,x=1110;
    int n=0;
    if((xR*xR-4)*(xL*xL-4)>0) cout << "Error\n\n";
	else
	{	while (fabs(x*x-4)>=Eps)
		{   n++;
			x=xL+fabs((xR-xL)*(xL*xL-4)/(xL*xL+xR*xR-8));
			if (x*x-4==0) break;    
		    if ((xL*xL-4)*(x*x-4)<0) xR=x;
			else xL=x;
		}
		cout << "x=" << x << "\n" << "n=" << n;
	}
}
int main()
{	float a,b,e;
	cin >> a >> b >> e;
	cout << "\nNewton\n" ;   
    newton N(a,e);
    N.solve();    
	cout << "Dichotomy\n" ;   
 	dichotomy D(a,b,e);
	D.solve();
	cout << "Secants\n" ;
    secant S(a,e,b);
	S.solve();
	getch();
	return 0;
}
